
/***************************************************************************
  03 April 1996 10:11
  
  Copyright (c) 1996 Robert van de Geijn and The University of Texas at Austin.
  See the file GNU_LICENSE for details on the gnu license

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  Written by:   Many People including:

  Gregory A. Baker, Center for Space Research,
  University of Texas at Austin  78722      baker@csr.utexas.edu

  Philip A. Alpatov, Department of Physics,
  University of Texas at Austin 78712.     philip@physics.utexas.edu

  James Overfelt, Department of Mathematics,
  University of Texas at Austin  78712.    overfelt@@math.utexas.edu
  
  John Andrew Gunnels, Department of Computer Sciences,
  University of Texas at Austin 78712.     gunnels@@cs.utexas.edu

  Greg Morrow, Department of Physics,
  University of Texas at Austin 78712.     morrow@@physics.utexas.edu

  Dr. Robert Van de Geijn, Department of Computer Sciences,
  University of Texas at Austin 78712.     rvdg@@cs.utexas.edu

***************************************************************************/



#include "PLA.h"

/********************************************************/
/* PLA_TRSM()                                            */
/********************************************************/
int PLA_Trsm (int side, int uplo, int transa, int diag, 
               PLA_Obj alpha, PLA_Obj a, PLA_Obj b)
{
   PLA_Trsm_enter(side, uplo, transa, diag, alpha, a, b);
   if(PLA_SIDE_LEFT == side)
   {
      if(PLA_LOWER_TRIANGULAR == uplo)
      {
         if(PLA_NO_TRANSPOSE == transa)
            PLA_Trsm_lln(alpha, a, b, diag);
         else
            PLA_Trsm_llt(alpha, a, b, diag);
      }
      else /* if(PLA_UPPER_TRIANGULAR == uplo) */
      {
         if(PLA_NO_TRANSPOSE == transa)
            PLA_Trsm_lun(alpha, a, b, diag);
         else
            PLA_Trsm_lut(alpha, a, b, diag);
      }
   }
   else  /* if(PLA_SIDE_RIGHT == side) */
   {
      if(PLA_LOWER_TRIANGULAR == uplo)
      {
         if(PLA_NO_TRANSPOSE == transa)
            PLA_Trsm_rln(alpha, a, b, diag);
         else
            PLA_Trsm_rlt(alpha, a, b, diag);
      }
      else /* if(PLA_UPPER_TRIANGULAR == uplo) */
      {
         if(PLA_NO_TRANSPOSE == transa)
            PLA_Trsm_run(alpha, a, b, diag);
         else
            PLA_Trsm_rut(alpha, a, b, diag);
      }
   }
   PLA_Trsm_exit(side, uplo, transa, diag, alpha, a, b);
   return(PLA_SUCCESS);
}



