
/* ------------------------------------------------------------------ */

int PLA_Obj_fill_zero( PLA_Obj laobj );

/* ------------------------------------------------------------------ */

enum {
  PLA_STATE_NORMAL     = 0 ,
  PLA_STATE_API_ACTIVE = 1 
};
enum {
  PLA_MODE_CLOSED     = 0 ,
  PLA_MODE_OPEN       = 1
};

int PLA_Obj_API_open( PLA_Obj laobj );
int PLA_Obj_API_close( PLA_Obj laobj );
int PLA_Obj_API_sync( PLA_Obj laobj );

int PLA_API_begin(    );
int PLA_API_end(    );

int PLA_Obj_API_mode( PLA_Obj laobj , int * state );

/* ------------------------------------------------------------------ */
/* Add local vector to global subvector */

int PLA_API_axpy_vector_to_global(
  int     size ,      /* Length */
  void  * alpha ,     /* Scalar */
  void  * local_obj , /* Local vector values */
  int     local_inc , /* Local vector increment */
  PLA_Obj laobj ,     /* Global vector */
  int     disp );     /* Global vector displacement */

/* Add global subvector to local vector */

int PLA_API_axpy_global_to_vector(
  int     size ,
  void  * alpha ,
  PLA_Obj laobj ,
  int     disp ,
  void  * local_obj ,
  int     local_inc );

/* Add local vector to global subvectors */

int PLA_API_multi_axpy_vector_to_global(
  int     nsub ,      /* Number of lengths */
  int   * size ,      /* Lengths */
  void  * alpha ,     /* Scalar */
  void  * local_obj , /* Local vector values */
  int     local_inc , /* Local vector increment */
  PLA_Obj laobj ,     /* Global vector */
  int   * disp );     /* Global vector displacement */

/* Add global subvectors to local vector */

int PLA_API_multi_axpy_global_to_vector(
  int     nsub ,
  int   * size ,
  void  * alpha ,
  PLA_Obj laobj ,
  int   * disp ,
  void  * local_obj ,
  int     local_inc );

/* Add local matrix to global (sub)matrix or (sub)multivector */

int PLA_API_axpy_matrix_to_global(
  int     size_row ,
  int     size_col ,
  void  * alpha ,
  void  * local_obj ,
  int     local_ldim ,
  PLA_Obj laobj ,
  int     disp_row ,
  int     disp_col );

/* Add global (sub)matrix or (sub)multivector to local matrix */

int PLA_API_axpy_global_to_matrix(
  int     size_row ,
  int     size_col ,
  void  * alpha ,
  PLA_Obj laobj ,
  int     disp_row ,
  int     disp_col ,
  void  * local_obj ,
  int     local_ldim );

/* Add local matrix to global (sub)matrices or (sub)multivectors */

int PLA_API_multi_axpy_matrix_to_global(
  int     nsub_row ,
  int     nsub_col ,
  int   * size_row ,
  int   * size_col ,
  void  * alpha ,
  void  * local_obj ,
  int     local_ldim ,
  PLA_Obj laobj ,
  int   * disp_row ,
  int   * disp_col );

/* Add global (sub)matrices or (sub)multivectors to local matrix */

int PLA_API_multi_axpy_global_to_matrix(
  int     nsub_row ,
  int     nsub_col ,
  int   * size_row ,
  int   * size_col ,
  void  * alpha ,
  PLA_Obj laobj ,
  int   * disp_row ,
  int   * disp_col ,
  void  * local_obj ,
  int     local_ldim );

/* ------------------------------------------------------------------ */

