#include "PLA.h"

int PLA_Chol_enter ( int uplo, PLA_Obj a )
{
   int check_parameter, instrument, check_seq, myrow, mycol;
   char current_routine[20] = "PLA_Chol";
   int objtype;
   MPI_Datatype datatype;
   PLA_Template template;
   PLA_Obj a_in = NULL;
   int  error = 0, original_error = 0;

   PLA_Stack_push_current( current_routine );

   PLA_Get_check_parameters ( & check_parameter );

   if ( PLA_CHECK_PARAMETER == check_parameter )
   {
      if ( uplo != PLA_LOWER_TRIANGULAR &&
           uplo != PLA_UPPER_TRIANGULAR ) PLA_Log_abort( "PLA_Chol_enter",
                                                         "PLA_Chol : uplo invalid",
                                                         PLA_ERROR_CODE,
                                                         original_error );

   /* check objects for validity */
      PLA_Obj_object_valid( a, "a", error, original_error);

    /* check object types */
      PLA_Obj_objtype_equal( a,     PLA_MATRIX,  "a", error, original_error );

    /* check datatypes */
      PLA_Obj_datatype_valid( a, "a", error, original_error );

    /* check dimensions */

      PLA_Obj_global_length_width_equal( a, a, "a and a", error, original_error );
   }


   PLA_Get_check_sequential ( &check_seq );
   if ( PLA_CHECK_SEQUENTIAL == check_seq ) { }

   PLA_Get_instrument ( &instrument );
   if ( PLA_INSTRUMENT == instrument ) { }

   return(original_error);
}


int PLA_Chol_exit ( int uplo, PLA_Obj a )
{
  char current_routine[20];
  int  instrument, check_seq, myrow, mycol;
  PLA_Obj c_out = NULL;
  PLA_Template template;

  PLA_Get_check_sequential ( &check_seq );

  if ( PLA_CHECK_SEQUENTIAL == check_seq ) { }

  PLA_Get_instrument ( &instrument );
  if ( PLA_INSTRUMENT == instrument ) { }

  PLA_Stack_pop_current( current_routine );

  return(PLA_SUCCESS);
}
