#include "PLA.h"
#include "POOCLA.h"

int test_matrix ( int my_pe, PLA_Template template )
{
   int i, j, r, c, length, width, r_dim;
   double * sourcematrix;
   MPI_Comm comm = MPI_COMM_NULL;
   FILE * pfile = NULL;
   POOCLA_Obj ooc = NULL;
   PLA_Obj obj = NULL;

   PLA_Temp_comm_all ( template, & comm );
   PLA_Temp_comm_col_size ( template, & r_dim );

   if ( my_pe == 0 )
   {
      printf ( "Input m, n\n" );
      scanf ( "%d%d", & length, & width );
   }
   MPI_Bcast ( & length, 1, MPI_INT, 0, comm );
   MPI_Bcast ( & width, 1, MPI_INT, 0, comm );

   if ( my_pe == 0 )
   {
      printf( "test %d %d\n", length, width );
      sourcematrix = pla_calloc ( length * width, sizeof ( double ) );

      for ( i = 0 ; i < length ; i++ )
         for ( j = 0 ; j < width ; j++ )
         {
            PLA_Temp_matrix_owner_rowcol ( template, i, j, & r, & c );
            sourcematrix [ j * length + i ] = c * r_dim + r + 1;
         }

      pfile = fopen ( "globalfile", "wb" );

      fwrite ( sourcematrix, sizeof ( double ), length * width, pfile );

      fclose ( pfile ); pfile = NULL;
      pla_free ( sourcematrix );  sourcematrix = NULL;
   }

   MPI_Barrier ( comm );

   convert_datafile_to_ooc_matrix ( "globalfile", length, width, MPI_DOUBLE, template,
                                    "distfile" );

   POOCLA_create ( template, MPI_DOUBLE, length, width, 0, 0,
                    PLA_MATRIX, PLA_UNDEFINED, PLA_UNDEFINED, "distfile", & ooc );

   POOCLA_read ( ooc, PLA_MATRIX, PLA_UNDEFINED, PLA_UNDEFINED, & obj );
printf ( "Uncomment to show\n" );
/*   PLA_Show ( obj );*/

   return ( 0 );
}
