#ifndef PRISM_LIST_H
#define PRISM_LIST_H

/* link list for end-game subproblems */

typedef struct prism_subproblem *PRISM_subproblem;

struct prism_subproblem {
   PRISM_subproblem next;
   int id, node;
   PLA_Obj A, Z, D;
   PLA_Obj sub, diag;
}; 

typedef struct prism_final_list *PRISM_final_list;

struct prism_final_list {
   PRISM_subproblem head;
   PRISM_subproblem tail;
};

void PRISM_subproblem_create( PRISM_subproblem *prob );
void PRISM_subproblem_delete( PRISM_subproblem *prob );
void PRISM_final_list_create( PRISM_final_list *list );
void PRISM_final_list_delete( PRISM_final_list *list );
void PRISM_final_list_insert( PRISM_subproblem prob, PRISM_final_list list );
void PRISM_final_list_get_first( PRISM_final_list list, PRISM_subproblem *prob );
void PRISM_final_list_get_next( PRISM_final_list list, PRISM_subproblem *prob );

/* misc utilities */
void PRISM_subproblem_print( PRISM_subproblem prob );
void PRISM_final_list_print( PRISM_final_list list );

#endif
